/*This code is made for controling model trains using a 2.4ghz reciver
 *Made by Krumps Projects on 11/23/2020
 *            
 *Base Code credits to
 * by Dejan Nedelkovski, www.HowToMechatronics.com
 * Using the Library: TMRh20/RF24, https://github.com/tmrh20/RF24/
 */

//Used in RF chip interface
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
RF24 radio(7, 8); // CE, CSN
const byte address[6] = "00001";
//Used in train logic

unsigned long v1; //Train 1 pot value
unsigned long v2; //Train 2 pot value
unsigned long v3; //Train 3 pot value
long d1; //Train 1 siganl velocity value
long d2; //Train 2 signal velocity value
long d3; //Train 3 signal velocity value
int s1; //value of Switch for train 1 direction
int s2; //value of Switch for train 2 direction
int s3; //value of Switch for train 3 direction
// Pin outs(You can change these to match your set up
int t1 = 2;  //Train 1 direction switch
int t2 = 3;  //Train 2 dircetion switch
int t3 = 4;  //Train 3 direction Switch


void setup() {
  Serial.begin(9600);
  pinMode(t1, INPUT_PULLUP);//Train 1
  pinMode(t2, INPUT_PULLUP);//Train 2
  pinMode(t3, INPUT_PULLUP);//Train 3
  //Used for RF chip
  radio.begin();
  radio.openWritingPipe(address);
  radio.setPALevel(RF24_PA_MIN);
  radio.stopListening();
}


void loop() {
  //This code gets the human interface panel info and converts to velocity train info
  
   //Train Control 1
   v1 = analogRead(0);
   s1 = digitalRead(t1);
   if(s1 == LOW){
    //d1 = ((v1*500)/1023)+1000;
    d1 = map(v1, 0, 1023, 0, -255);
   }
   else{
    //d1= -(((v1*500)/1023)-1000);
    d1 = map(v1, 0, 1023, 0, 255);
   }
   
   //Train Control 2
   v2 = analogRead(1);
   s2 = digitalRead(t2);
   if(s2 == LOW){
    d2 = ((v2*500)/1023)+1000;
   }
   else{
    d2= -(((v2*500)/1023)-1000);
   }

   //Train Control 3
   v3 = analogRead(2);
   s3 = digitalRead(t3);
   if(s3 == LOW){
    d3 = ((v3*500)/1023)+1000;
   }
   else{
    d3= -(((v3*500)/1023)-1000);
   }
   
  //This code send the data to the trains
  // const char text[] = d1;
  int text = d1;
 
  Serial.println(text);
  radio.write(&text, sizeof(text));
  delay(100);
}
